package mki.xml2csv.gui;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.table.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.event.*;
import org.w3c.dom.*;
import mki.xml2csv.access.DomAccess;
//import mki.xml.model.*;
import mki.xml2csv.access.*;
import mki.xml2csv.model.*;
import mki.xqueryconstructor.core.*;
import mki.xqueryconstructor.util.*;

/**
 * Config_XML2CSVCFrame
 * @author nagashima
 * @version 1.0
 */
public class ConfigXml2CsvMainFrame extends JFrame {
  private Container cont;
  private DomAccess docAccess = null;
  private JPanel contentPane;
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenuFile = new JMenu();
  private JMenuItem jMenuFileExit = new JMenuItem();
  private JMenu jMenuHelp = new JMenu();
  private JMenuItem jMenuHelpAbout = new JMenuItem();
  private ImageIcon image1;
  private ImageIcon image2;
  private ImageIcon image3;
  private JLabel statusBar = new JLabel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel pntBase = new JPanel();
  private JButton btnAdd = new JButton();
  private JPanel jPanel4 = new JPanel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JTextField txtXmlRoot = new JTextField();
  private JLabel jLabel1 = new JLabel();
  private JButton btnFileSave = new JButton();
  private JPanel jPanel3 = new JPanel();
  private GridLayout gridLayout1 = new GridLayout();
  private JButton btnSave = new JButton();
  private JButton btnNew = new JButton();
  private JPanel jPanel2 = new JPanel();
  private GridLayout gridLayout2 = new GridLayout();
  private JButton btnDelete = new JButton();
  private JButton btnIns = new JButton();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JButton btnClose = new JButton();
  private JButton btnRead = new JButton();
  private JButton btnDown = new JButton();
  private JButton btnUp = new JButton();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel jPanel1 = new JPanel();
  private JButton btnDel = new JButton();
  private JTextField txtConfigId = new JTextField();
  private JTree jTree1 = null;
  private Xml2CsvConfigModel model = null;
  private Xml2CsvNeoCoreAccess neoaccess = null;
  private String[] tblColNames = {"`","XML^O", "INDEX","CSVtB[h","CSVtB[h^Cv"};
  private DefaultTableModel tblmodel = null;
  private DefaultListModel lstmodel = null;
  private JTable jTable1 = new JTable();
  private static final int INIT_MODE = 0;
  private static final int INSERT_MODE = 1;
  private static final int UPDATE_MODE = 2;
  private JCheckBox chkType = new JCheckBox();
  private JButton btnUpd = new JButton();
  private JLabel jLabel9 = new JLabel();
  private int mode = 0;
  private JLabel jLabel10 = new JLabel();
  private JButton btnConn = new JButton();
  private String selectedId = "";
  private JScrollPane jScrollPane3 = new JScrollPane();
  private JButton btnMultiAdd = new JButton();
  private JButton btnMultiDel = new JButton();
  private JLabel jLabel8 = new JLabel();
  private JTextField txtCsvFile = new JTextField();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private JTextField txtMemo = new JTextField();
  private Xml2CsvCellRenderer cellrenderer = new Xml2CsvCellRenderer();
  private Map mapXml = new HashMap();
  private java.util.List lstXml = null;
  private String record = null;
  private String[][] xmlpath = null;
  private JButton btnQuery = new JButton();
  private DefaultComboBoxModel condmodel = null;
  private JList lstCond = new JList();
  private java.util.List lstCondition = null;
  private JPopupMenu popup = new JPopupMenu();
  private JButton btnMulti = new JButton();
  private int querysize = 1000;
  /**
   * vpeBt@C
   */
  private ResourceBundle prop = null;
  /**
   * encording
   */
  private String encoding = null;
  /**
   * CSVtB[h^Cv̔z
   */
  private String[] csvfieldtype = null;
  private JLabel jLabel6 = new JLabel();
  private JTextField txtBaseNode = new JTextField();
  private JPanel jPanel5 = new JPanel();
  private BorderLayout borderLayout3 = new BorderLayout();
  private JButton btnBaseNode = new JButton();
  private JPanel jPanel6 = new JPanel();
  private JRadioButton rdoWhere = new JRadioButton();
  private JRadioButton rdoFor = new JRadioButton();
  private ButtonGroup buttonGroup1 = new ButtonGroup();

  //t[̃rh
  public ConfigXml2CsvMainFrame() throws Exception {
    // RegyC擾
    cont = getContentPane();
    docAccess = new DomAccess();
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      setMode(INIT_MODE);
      String[][] rowData = null;
      tblmodel = new Xml2CsvTableModel();
      //tblmodel = new DefaultTableModel(rowData, tblColNames);
      //tblmodel.setDataVector(rowData, tblColNames);
      jTable1.setModel(tblmodel);
      jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

      //jTable1.setDefaultRenderer(Object.class, cellrenderer);
      try {
        prop = ResourceBundle.getBundle("xml2csv");
      }
      catch (Exception e1) {
        System.out.println("vpeBt@C܂");
        throw e1;
      }
      String host = prop.getString("neocore.host");
      String port = prop.getString("neocore.port");
      String userid = prop.getString("neocore.userid");
      String password = prop.getString("neocore.password");
      encoding = prop.getString("encoding");
      querysize = Integer.parseInt(prop.getString("query.size"));
      String str = prop.getString("csvfieldtype");
      if (str == null || str.equals("")) {
        str = "STRING,INT,DOUBLE";
      }
      StringTokenizer st = new StringTokenizer(str, ",");
      csvfieldtype = new String[st.countTokens()];
      int a = 0;
      while (st.hasMoreTokens()) {
        csvfieldtype[a] = st.nextToken();
        a++;
      }
      //NeoCoreANZXNX̃CX^X
      neoaccess = new Xml2CsvNeoCoreAccess(host,Integer.parseInt(port),userid,password);
      //jLabel8.setVisible(false);
      //jTextField4.setVisible(false);
      txtBaseNode.setEditable(false);
      txtXmlRoot.setEditable(false);
      //jLabel6.setVisible(false);
      //txtBaseNode.setVisible(false);
      //|bvAbvj[쐬iXMLc[ENbNƂɕ\j
      JMenuItem menuItem2 = new JMenuItem("`ǉ");
      menuItem2.addActionListener(new ConfigXml2CsvMainFrame_menuItem2_actionAdapter(this));
      popup.add(menuItem2);
      JMenuItem menuItem1 = new JMenuItem("ǉ");
      menuItem1.addActionListener(new ConfigXml2CsvMainFrame_menuItem1_actionAdapter(this));
      popup.add(menuItem1);
      JMenuItem menuItem3 = new JMenuItem("m[hݒ");
      menuItem3.addActionListener(new ConfigXml2CsvMainFrame_menuItem3_actionAdapter(this));
      popup.add(menuItem3);

      //setControl();
    }
    catch(Exception e) {
      e.printStackTrace();
      throw e;
    }
  }

  //R|[lg̏
  private void jbInit() throws Exception  {
    image1 = new ImageIcon(mki.xml2csv.gui.ConfigXml2CsvMainFrame.class.getResource("openFile.png"));
    image2 = new ImageIcon(mki.xml2csv.gui.ConfigXml2CsvMainFrame.class.getResource("closeFile.png"));
    image3 = new ImageIcon(mki.xml2csv.gui.ConfigXml2CsvMainFrame.class.getResource("help.png"));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(800, 600));
    this.setTitle("Config_XML2CSV");
    statusBar.setText(" ");
    jMenuFile.setText("t@C");
    jMenuFileExit.setText("I");
    jMenuFileExit.addActionListener(new ConfigXml2CsvMainFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("wv");
    jMenuHelpAbout.setText("o[W");
    jMenuHelpAbout.addActionListener(new ConfigXml2CsvMainFrame_jMenuHelpAbout_ActionAdapter(this));
    pntBase.setDebugGraphicsOptions(0);
    pntBase.setLayout(null);
    btnAdd.setBounds(new Rectangle(25, 473, 71, 23));
    btnAdd.setText("ǉ");
    btnAdd.addActionListener(new ConfigXml2CsvMainFrame_btnAdd_actionAdapter(this));
    jPanel4.setBounds(new Rectangle(365, 65, 404, 70));
    jPanel4.setLayout(borderLayout2);
    jScrollPane1.setBounds(new Rectangle(18, 57, 332, 246));
    txtXmlRoot.setText("");
    txtXmlRoot.setBounds(new Rectangle(19, 30, 222, 20));
    jLabel1.setText("`ID");
    btnFileSave.setBounds(new Rectangle(401, 506, 102, 23));
    btnFileSave.setText("t@Co");
    btnFileSave.addActionListener(new ConfigXml2CsvMainFrame_btnFileSave_actionAdapter(this));
    jPanel3.setLayout(gridLayout2);
    gridLayout1.setColumns(1);
    gridLayout1.setHgap(0);
    gridLayout1.setRows(3);
    gridLayout1.setVgap(5);
    btnSave.setBounds(new Rectangle(516, 506, 71, 23));
    btnSave.setText("ۑ");
    btnSave.addActionListener(new ConfigXml2CsvMainFrame_btnSave_actionAdapter(this));
    btnNew.setBounds(new Rectangle(251, 28, 101, 23));
    btnNew.setText("XML\Ǎ");
    btnNew.addActionListener(new ConfigXml2CsvMainFrame_btnNew_actionAdapter(this));
    jPanel2.setLayout(gridLayout1);
    jPanel2.setBorder(null);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(3);
    gridLayout2.setVgap(5);
    btnDelete.setBounds(new Rectangle(600, 506, 77, 23));
    btnDelete.setText("폜");
    btnDelete.addActionListener(new ConfigXml2CsvMainFrame_btnDelete_actionAdapter(this));
    btnIns.setBounds(new Rectangle(104, 473, 71, 23));
    btnIns.setText("}");
    btnIns.addActionListener(new ConfigXml2CsvMainFrame_btnIns_actionAdapter(this));
    jScrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jScrollPane2.setBounds(new Rectangle(19, 335, 752, 128));
    btnClose.setBounds(new Rectangle(690, 506, 71, 23));
    btnClose.setHorizontalAlignment(SwingConstants.CENTER);
    btnClose.setText("");
    btnClose.addActionListener(new ConfigXml2CsvMainFrame_btnClose_actionAdapter(this));
    btnRead.setBounds(new Rectangle(364, 28, 115, 23));
    btnRead.setText("`Ǎ");
    btnRead.addActionListener(new ConfigXml2CsvMainFrame_btnRead_actionAdapter(this));
    btnDown.setBounds(new Rectangle(422, 473, 71, 23));
    btnDown.setText("");
    btnDown.addActionListener(new ConfigXml2CsvMainFrame_btnDown_actionAdapter(this));
    btnUp.setBounds(new Rectangle(343, 473, 71, 23));
    btnUp.setText("");
    btnUp.addActionListener(new ConfigXml2CsvMainFrame_btnUp_actionAdapter(this));
    borderLayout2.setHgap(5);
    borderLayout2.setVgap(5);
    jPanel1.setLayout(null);
    btnDel.setBounds(new Rectangle(263, 473, 71, 23));
    btnDel.setText("폜");
    btnDel.addActionListener(new ConfigXml2CsvMainFrame_btnDel_actionAdapter(this));
    txtConfigId.setText("");
    jPanel1.setBounds(new Rectangle(-2, 0, 803, 602));
    chkType.setText("CSVtB[h^Cvw");
    chkType.setBounds(new Rectangle(360, 302, 173, 23));
    chkType.addItemListener(new ConfigXml2CsvMainFrame_chkType_itemAdapter(this));
    btnUpd.setBounds(new Rectangle(184, 473, 71, 23));
    btnUpd.setText("XV");
    btnUpd.addActionListener(new ConfigXml2CsvMainFrame_btnUpd_actionAdapter(this));
    jLabel9.setText("XML\");
    jLabel9.setBounds(new Rectangle(19, 13, 85, 15));
    jLabel10.setText("`");
    jLabel10.setBounds(new Rectangle(19, 313, 86, 15));
    btnConn.setBounds(new Rectangle(653, 28, 115, 23));
    btnConn.setActionCommand("ڑ");
    btnConn.setText("ڑ");
    btnConn.addActionListener(new ConfigXml2CsvMainFrame_btnConn_actionAdapter(this));
    jScrollPane3.setBounds(new Rectangle(366, 164, 403, 71));
    btnMultiAdd.setBounds(new Rectangle(616, 241, 71, 23));
    btnMultiAdd.setText("ǉ");
    btnMultiAdd.addActionListener(new ConfigXml2CsvMainFrame_btnMultiAdd_actionAdapter(this));
    btnMultiDel.setBounds(new Rectangle(696, 241, 71, 23));
    btnMultiDel.setText("폜");
    btnMultiDel.addActionListener(new ConfigXml2CsvMainFrame_btnMultiDel_actionAdapter(this));
    jLabel8.setText("CSVt@Co͐");
    jLabel8.setBounds(new Rectangle(363, 273, 99, 21));
    txtCsvFile.setText("");
    txtCsvFile.setBounds(new Rectangle(479, 272, 291, 21));
    jLabel2.setText("");
    jLabel3.setText("l");
    txtMemo.setText("");
    btnQuery.setBounds(new Rectangle(373, 241, 101, 23));
    btnQuery.setText("XQuery쐬");
    btnQuery.addActionListener(new ConfigXml2CsvMainFrame_btnQuery_actionAdapter(this));
    btnMulti.setBounds(new Rectangle(483, 241, 123, 23));
    btnMulti.setText("}`IJX");
    btnMulti.addActionListener(new ConfigXml2CsvMainFrame_btnMulti_actionAdapter(this));
    jLabel6.setText("m[h");
    txtBaseNode.setText("");
    jPanel5.setLayout(borderLayout3);
    btnBaseNode.setText("ݒ");
    btnBaseNode.addActionListener(new ConfigXml2CsvMainFrame_btnBaseNode_actionAdapter(this));
    jTable1.addMouseListener(new ConfigXml2CsvMainFrame_jTable1_mouseAdapter(this));
    jPanel6.setBounds(new Rectangle(354, 135, 238, 27));
    rdoWhere.setText("where߂쐬");
    rdoFor.setSelected(true);
    rdoFor.setText("for߂Ɋ܂");
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(pntBase,  BorderLayout.CENTER);
    pntBase.add(jPanel1, null);
    jPanel3.add(jLabel1, null);
    jPanel3.add(jLabel3, null);
    jPanel3.add(jLabel6, null);
    jPanel4.add(jPanel2, BorderLayout.CENTER);
    jPanel1.add(jScrollPane2, null);
    jPanel1.add(btnUpd, null);
    jPanel1.add(btnAdd, null);
    jPanel1.add(btnUp, null);
    jPanel1.add(btnDown, null);
    jPanel1.add(btnDel, null);
    jPanel1.add(btnIns, null);
    jPanel1.add(btnFileSave, null);
    jPanel1.add(btnSave, null);
    jPanel1.add(btnDelete, null);
    jPanel1.add(btnClose, null);
    jPanel1.add(jPanel4, null);
    jScrollPane2.getViewport().add(jTable1, null);
    jPanel2.add(txtConfigId, null);
    jPanel2.add(txtMemo, null);
    jPanel2.add(jPanel5, null);
    jPanel5.add(txtBaseNode,  BorderLayout.CENTER);
    jPanel5.add(btnBaseNode,  BorderLayout.EAST);
    jPanel1.add(jLabel9, null);
    jPanel1.add(txtXmlRoot, null);
    jPanel1.add(btnNew, null);
    jPanel1.add(jScrollPane1, null);
    jPanel1.add(jLabel10, null);
    jPanel1.add(btnRead, null);
    jPanel1.add(jScrollPane3, null);
    jScrollPane3.getViewport().add(lstCond, null);
    jPanel4.add(jPanel3, BorderLayout.WEST);
    jPanel1.add(btnConn, null);
    jPanel1.add(chkType, null);
    jPanel1.add(txtCsvFile, null);
    jPanel1.add(jLabel8, null);
    jPanel1.add(btnMultiAdd, null);
    jPanel1.add(btnMultiDel, null);
    jPanel1.add(btnQuery, null);
    jPanel1.add(btnMulti, null);
    jPanel1.add(jPanel6, null);
    jPanel6.add(jLabel2, null);
    jPanel6.add(rdoFor, null);
    jPanel6.add(rdoWhere, null);
    buttonGroup1.add(rdoFor);
    buttonGroup1.add(rdoWhere);
  }

  /**
   * [hɂă{^Ԃω
   *
   * @param mode int
   */
  private void setMode(int mode){
    this.mode = mode;
    switch(mode){
      case INIT_MODE:
        btnSave.setEnabled(false);
        btnFileSave.setEnabled(false);
        btnDelete.setEnabled(false);
        btnConn.setEnabled(false);
        btnMultiAdd.setEnabled(false);
        btnMultiDel.setEnabled(false);
        btnAdd.setEnabled(false);
        btnIns.setEnabled(false);
        btnUpd.setEnabled(false);
        btnDel.setEnabled(false);
        btnUp.setEnabled(false);
        btnDown.setEnabled(false);
        btnQuery.setEnabled(false);
        btnMulti.setEnabled(false);
        btnBaseNode.setEnabled(false);
        chkType.setEnabled(false);
        rdoFor.setEnabled(false);
        rdoWhere.setEnabled(false);
        break;
      case INSERT_MODE:
        btnSave.setEnabled(true);
        btnFileSave.setEnabled(true);
        btnDelete.setEnabled(false);
        btnConn.setEnabled(true);
        btnMultiAdd.setEnabled(true);
        btnMultiDel.setEnabled(true);
        btnAdd.setEnabled(true);
        btnIns.setEnabled(true);
        btnUpd.setEnabled(true);
        btnDel.setEnabled(true);
        btnUp.setEnabled(true);
        btnDown.setEnabled(true);
        btnQuery.setEnabled(true);
        btnMulti.setEnabled(true);
        btnBaseNode.setEnabled(true);
        chkType.setEnabled(true);
        rdoFor.setEnabled(true);
        rdoWhere.setEnabled(true);
        break;
      case UPDATE_MODE:
        btnSave.setEnabled(true);
        btnFileSave.setEnabled(true);
        btnDelete.setEnabled(true);
        btnConn.setEnabled(true);
        btnMultiAdd.setEnabled(true);
        btnMultiDel.setEnabled(true);
        btnAdd.setEnabled(true);
        btnIns.setEnabled(true);
        btnUpd.setEnabled(true);
        btnDel.setEnabled(true);
        btnUp.setEnabled(true);
        btnDown.setEnabled(true);
        btnQuery.setEnabled(true);
        btnMulti.setEnabled(true);
        btnBaseNode.setEnabled(true);
        chkType.setEnabled(true);
        rdoFor.setEnabled(true);
        rdoWhere.setEnabled(true);
        break;
    }
  }
  /**
   * j[[t@C|I]NbN̏
   *
   * @param e ActionEvent
   */
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  /**
   * j[[wv|o[W]NbN̏
   *
   * @param e ActionEvent
   */
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    ConfigXml2CsvMainFrame_AboutBox dlg = new ConfigXml2CsvMainFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }

  //EBhEꂽƂɏI悤ɃI[o[Ch
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  /**
   * XML\Ǎ{^NbN
   *
   * @param e ActionEvent
   */
  void btnNew_actionPerformed(ActionEvent e) {
    String xmlroot = txtXmlRoot.getText().trim();
    Iterator it = null;
      String[] ary = neoaccess.getDocumentList(true);
      DefaultComboBoxModel docModel = new DefaultComboBoxModel();
      for (int i = 0; i < ary.length; i++) {
        if(ary[i].equals("NeoCore") || ary[i].equals("xml2csv")){
          continue;
        }
        docModel.addElement(ary[i]);
      }
      Xml2CsvDocumentListDialog dlg = showDocumentListDialog("hLgꗗ",
          docModel);
      if (!dlg.okFlag || dlg.getSelectedDoc() == null) {
        return;
      }
      xmlroot = dlg.getSelectedDoc().toString();
    int count = neoaccess.queryCountXML("/ND/" + xmlroot);
    if(count == 0){
      MessageDialog.showInformationMessage(cont,"w肳ꂽXML݂͑Ă܂","Config_XML2CSV");
      jTree1 = null;
      jScrollPane1.setViewportView(jTree1);
      model = new Xml2CsvConfigModel();
      setControl();
      setMode(INIT_MODE);
      return;
    }

    lstCondition = new ArrayList();

    lstXml = new ArrayList();
    showXmlTree(neoaccess,xmlroot);
    //model.clear();
    model = new Xml2CsvConfigModel();
    //model.document = xmlroot;
    model.setDocument(xmlroot);
    try {
      model.setHost(prop.getString("config.neocore.host"));
      model.setPort(prop.getString("config.neocore.port"));
      model.setUserid(prop.getString("config.neocore.userid"));
      model.setPassword(prop.getString("config.neocore.password"));
    }
    catch (Exception e1) {
      System.out.println(e1);
      System.out.println("ݒt@C܂");
    }

    //Iterator it = mapXml.keySet().iterator();
    //Iterator it = lstXml.iterator();
    //while(it.hasNext()){
      //String[] ary = (String[])it.next();
      ////System.out.println("key:" + ary[0] + "Avalue:" + ary[1]);
    //}

    //record = neoaccess.getRecordTag("/ND/" + xmlroot);
    //record = "/ND/" + xmlroot + record;
    //System.out.println("R[h^O=" + record);
    //System.out.println("for $rec in " + record);
    //mapCond.put();

    record = neoaccess.getRecordTagPath("/ND/" + xmlroot);
    //System.out.println("record="+record);
    //model.strRecordTag = rec;
    model.setStrRecordTag(record);

    /*
    int cnt = 0;
    xmlpath = new String[lstXml.size()][5];
    it = lstXml.iterator();
    while(it.hasNext()){
      String[] ary = (String[])it.next();
      xmlpath[cnt][0]=ary[0];
      xmlpath[cnt][1]=ary[1];
      xmlpath[cnt][2]=ary[2];
      xmlpath[cnt][3]=ary[3];
      xmlpath[cnt][4]=ary[4];
      cnt++;
    }
    */

    /*
    cnt = 1;
    //String recpath = record;
    for(int i=0;i < xmlpath.length;i++){
      String strRep = xmlpath[i][1];
      String strRep1 = "";
      String strRep2 = "";
      //System.out.println("recpath" + recpath);
      if(strRep.indexOf("@")!=-1 || xmlpath[i][0].indexOf(record.substring(3))==-1){
        //System.out.println("recpath2" + recpath);
        continue;
      }else{
        xmlpath[i][2] = "for";
        xmlpath[i][4] = strRep;
        if(strRep.equals(record)){
          xmlpath[i][3] = "$rec";
          //mapCond.put(xmlpath[i][0],xmlpath[i][2] + " " + xmlpath[i][3] + "in " + xmlpath[i][4]);
        }else{
          xmlpath[i][3] = "$f" + cnt;
          cnt++;
        }
        //recpath = xmlpath[i][3];
        strRep1 = xmlpath[i][3];
        strRep2 = xmlpath[i][4];
      }
      for(int j=i;j < xmlpath.length;j++){
        //System.out.println("xmlpath[0]:" + xmlpath[j][0] + "Axmlpath[1]:" + xmlpath[j][1] + "Axmlpath[2]:" + xmlpath[j][2] + "Axmlpath[3]:" + xmlpath[j][3] + "Axmlpath[4]:" + xmlpath[j][4]);
        //System.out.println("strRep1" + strRep1);
        //System.out.println("strRep2" + strRep2);
        if(strRep1.startsWith("$"))
          strRep1 = "\\" + strRep1;
        if(strRep2.startsWith("$"))
          strRep2 = "\\" + strRep2;

        //System.out.println("strRep1" + strRep1);
        //System.out.println("strRep2" + strRep2);
        //if(strRep.equals(record)){
          //xmlpath[j][2] = "for";
          //xmlpath[j][3] = "$rec";
          //xmlpath[j][4] = record;
          Pattern pattern = Pattern.compile(strRep2);
          Matcher matcher = pattern.matcher(xmlpath[j][1]);
          xmlpath[j][1] = matcher.replaceFirst(strRep1);
        //}
        //System.out.println("xmlpath[0]:" + xmlpath[j][0] + "Axmlpath[1]:" + xmlpath[j][1] + "Axmlpath[2]:" + xmlpath[j][2] + "Axmlpath[3]:" + xmlpath[j][3] + "Axmlpath[4]:" + xmlpath[j][4]);
      }
    }
    System.out.println("#############################");
    for(int i=0;i < xmlpath.length;i++){
      System.out.println("xmlpath[0]:" + xmlpath[i][0] + ",xmlpath[1]:" + xmlpath[i][1] + ",xmlpath[2]:" + xmlpath[i][2] + ",xmlpath[3]:" + xmlpath[i][3] + ",xmlpath[4]:" + xmlpath[i][4]);
    }
    */

    setControl();
    setMode(INSERT_MODE);
    //this.txtConfigId.setEditable(true);


    condmodel = new DefaultComboBoxModel();
    lstCond.setModel(condmodel);
  }

  /**
   * w肳ꂽXML̃c[\\
   *
   * @param neoaccess Xml2CsvNeoCoreAccess
   * @param xmlroot String
   */
  private void showXmlTree(Xml2CsvNeoCoreAccess neoaccess,String xmlroot){
    try{
      String str = neoaccess.queryTreeXML("/ND/" + xmlroot);
      Document docResult = docAccess.parseString(str,"UTF-8");
      String nodelist = docResult.getDocumentElement().getChildNodes().item(0).getNodeValue().trim();
      if(nodelist.trim().equals("")){
        MessageDialog.showInformationMessage(cont,"w肳ꂽXML݂͑Ă܂","Config_XML2CSV");
        return;
      }
      // c[쐬
      DefaultMutableTreeNode treenode = new DefaultMutableTreeNode("ND");
      DefaultMutableTreeNode treenode2 = new DefaultMutableTreeNode(xmlroot);
      treenode.add(treenode2);

      //DefaultMutableTreeNode treenode = new DefaultMutableTreeNode(xmlroot);
      //TreePath tpath = treenode.getPath();
      jTree1 = new JTree(treenode);
      jTree1.addTreeSelectionListener(new Xml2CsvTreeSelectionListener());
      DefaultTreeSelectionModel treeSelModel = new DefaultTreeSelectionModel();
      treeSelModel.setSelectionMode(DefaultTreeSelectionModel.SINGLE_TREE_SELECTION);
      jTree1.setSelectionModel(treeSelModel);
      addNode(treenode2, "", neoaccess,"/ND/" + xmlroot);
      // c[XN[yCɊi[
      jScrollPane1.setViewportView(jTree1);
      //System.out.println("count = " + jTree1.getRowCount());
      expandNode(treenode);

      jTree1.addMouseListener(new ConfigXml2CsvMainFrame_jTree1_mouseAdapter(this));

    }catch(Exception ex){
      System.out.println("e = " + ex);
      //throw e;
    }
  }
  /**
   * XMLc[WJiċAIɌĂяoj
   *
   * @param tnode DefaultMutableTreeNode
   */
  private void expandNode(DefaultMutableTreeNode tnode) {
    if(!tnode.isLeaf()){
      TreeNode[] node_ary = tnode.getPath();
      TreePath tpath = new TreePath(node_ary);
      jTree1.expandPath(tpath);
      for(int j=0;j<tnode.getChildCount();j++){
        expandNode((DefaultMutableTreeNode)tnode.getChildAt(j));
      }
    }
  }
  /**
   * XMLc[\ziċAIɌĂяoj
   *
   * @param tnode DefaultMutableTreeNode
   * @param node String
   * @param neoaccess Xml2CsvNeoCoreAccess
   * @param rootnode String
   */
  private void addNode(DefaultMutableTreeNode tnode ,String node, Xml2CsvNeoCoreAccess neoaccess,String rootnode) {
    String result = null;
    String query = null;
    try{
      if(node.equals("")){
        query = rootnode;
      }else{
        query = rootnode + "/" + node;
      }
      //System.out.println("query = " + query);
      //System.out.println("node = " + rootnode + "/" + node);
      result = neoaccess.queryTreeXML(query);
      //System.out.println("result = " + result);
      Document doc = docAccess.parseString(result,"UTF-8");

      //[ghLgGg擾
      Element element = doc.getDocumentElement();
      //System.out.println("name = " + element.getTagName());
      //System.out.println("val = " + element.getNodeValue());
      result = element.getChildNodes().item(0).getNodeValue().trim();
      //System.out.println("result2 = " + result);

    }catch(Exception e){
      System.out.println("e = " + e);
      //throw e;
    }
    StringTokenizer st = new StringTokenizer(result, ",");
    while (st.hasMoreTokens()) {
      String val = st.nextToken();
      int count = neoaccess.queryCountXML(query + "/" + val);
      if(count == 0){
        continue;
      }
      //System.out.println("node : " + node);
      //System.out.println("l : " + val);
      DefaultMutableTreeNode tempnode =
        new DefaultMutableTreeNode(val);
      // elementł΍ċA
      if (!val.startsWith("@")) {
        // ċAIɃm[hǉ
        if(node.equals("")){
          addNode(tempnode, val, neoaccess,rootnode);
        }else{
          addNode(tempnode, node + "/" + val, neoaccess,rootnode);
        }
      }
      tnode.add(tempnode);
    }
  }

  /**
   * t@Co̓{^NbN
   *
   * @param e ActionEvent
   */
  void btnFileSave_actionPerformed(ActionEvent e) {
    if(!CheckData()){
      return;
    }

    JFileChooser fdlg = new JFileChooser();
    fdlg.setDialogType(JFileChooser.SAVE_DIALOG);
    fdlg.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
    fdlg.setDialogTitle("ۑ");
    //fdlg.addChoosableFileFilter(new Xml2CsvFilter());
    if(fdlg.showSaveDialog(cont) != JFileChooser.APPROVE_OPTION)
      return;
    String select_file = fdlg.getSelectedFile().getAbsolutePath();
    System.out.println("select_file : " + select_file);

    try{
      //BufferedWriter bw = new BufferedWriter(new FileWriter(new File(select_file)));
      OutputStreamWriter objOsr = new OutputStreamWriter(
          new FileOutputStream(select_file), encoding);
      BufferedWriter bw = new BufferedWriter(objOsr);
      bw.write(model.getXml(encoding));
      bw.close();
    }catch(Exception ex){
      System.out.println("G[F"+ex);
    }
  }
  /**
   * ۑ{^NbN
   *
   * @param e ActionEvent
   */
  void btnSave_actionPerformed(ActionEvent e) {
    if(!CheckData()){
      return;
    }
    if(JOptionPane.OK_OPTION!=MessageDialog.showConfirmMessage(cont, "ۑ܂H","Config_XML2CSV")){
      return;
    }
    String str = null;
    if(mode==UPDATE_MODE && selectedId.trim().equals(model.getId().trim())){
      //str = neoaccess.modifyConfigXML(model.id, model.getXml());
      str = neoaccess.deleteConfigXML(model.getId());
      //str = neoaccess.storeConfigXML(model.getXml(encoding));
      str = neoaccess.storeXMLBinary(model.getXml(encoding),encoding);
    }else if(mode==INSERT_MODE || (mode==UPDATE_MODE && !selectedId.trim().equals(model.getId().trim()))){
      int count = neoaccess.queryConfigCountXML(model.getId());
      if (count == 1) {
        MessageDialog.showInformationMessage(cont,"w肳ꂽ`ID͂łɑ݂Ă܂","Config_XML2CSV");
        return;
      }
      //str = neoaccess.storeConfigXML(model.getXml(encoding));
      str = neoaccess.storeXMLBinary(model.getXml(encoding),encoding);
    }
    System.out.println("result = " + str);
  }

  /**
   * `ۑ̃`FbN
   *
   * @return boolean
   */
  private boolean CheckData() {
    boolean flag = true;
    boolean typeflag = true;
    boolean multiflag = false;
    model.setAutoCreatedQueryFlag(true);
    //model.id = this.txtConfigId.getText();
    model.setId(this.txtConfigId.getText());
    //model.memo = this.txtMemo.getText();
    model.setMemo(this.txtMemo.getText());
    //model.host = this.txtHost.getText();
    //model.port = this.txtPort.getText();
    //model.userid = this.txtUserId.getText();
    //model.password = this.txtPassword.getText();
    //model.query = this.txtQuery.getText();
    model.setQuery(this.txtBaseNode.getText());
    //model.strRecordTag = this.txtRecordTag.getText();
    //model.csvfile = this.txtCsvFile.getText();
    model.setCsvfile(this.txtCsvFile.getText());
    model.typeFlag = this.chkType.isSelected();
    String tmp = "";
    for (int i = 0; i < lstmodel.size(); i++) {
      tmp = tmp + "," + lstmodel.elementAt(i);
    }
    if (!tmp.equals("")) {
      model.multioccurrence = tmp.substring(1);
    }
    else {
      model.multioccurrence = "";
    }
    model.lstFields = new ArrayList();
    Map mapCnt = new HashMap();
    for (int i = 0; i < tblmodel.getRowCount(); i++) {
      String[] str = new String[4];
      str[0] = tblmodel.getValueAt(i, 1).toString();
      str[1] = tblmodel.getValueAt(i, 2).toString();
      str[2] = tblmodel.getValueAt(i, 3).toString();
      str[3] = tblmodel.getValueAt(i, 4).toString();
      model.lstFields.add(str);
      if (mapCnt.get(str[2]) == null) {
        mapCnt.put(str[2], "1");
      }
      else {
        flag = false;
      }
      if (chkType.isSelected()) {
        if (str[3] == null || str[3].equals("")) {
          typeflag = false;
        }
      }
    }
    for (int j = 0; j < lstmodel.size(); j++) {
      multiflag = false;
      for (int k = 0; k < tblmodel.getRowCount(); k++) {
        String s = tblmodel.getValueAt(k, 1).toString();
        if (lstmodel.elementAt(j).equals(s)) {
          multiflag = true;
        }
      }
      if (!multiflag)
        break;
    }
    if (!multiflag && lstmodel.size() > 0) {
      MessageDialog.showInformationMessage(cont,"}`IJXɎw肳ꂽ^O`Ɏw肳Ă܂","Config_XML2CSV");
      return false;
    }
    //XQuery
    //model.query = XQueryConstructor();

    if (!flag) {
      MessageDialog.showWarningMessage(cont, "CSVtB[hdĂ܂","Config_XML2CSV");
      return false;
    }
    if (!typeflag) {
      MessageDialog.showWarningMessage(cont, "CSVtB[h^Cvw肳Ă܂","Config_XML2CSV");
      return false;
    }
    if (model.getHost() == null ||
        model.getPort() == null ||
        model.getUserid() == null ||
        model.getPassword() == null ||
        model.getHost().equals("") ||
        model.getPort().equals("") ||
        model.getUserid().equals("") ||
        model.getPassword().equals("")) {
      MessageDialog.showWarningMessage(cont, "ڑ񂪎w肳Ă܂","Config_XML2CSV");
      return false;
    }
    if (model.getId().equals("")) {
      MessageDialog.showWarningMessage(cont, "`IDw肳Ă܂","Config_XML2CSV");
      return false;
    }
    if (model.lstFields.size() == 0) {
      MessageDialog.showWarningMessage(cont, "`񂪎w肳Ă܂","Config_XML2CSV");
      return false;
    }
    //boolean f = neoaccess.checkQuery(model.query);
    if (!neoaccess.checkQuery(model.getQuery())) {
      MessageDialog.showWarningMessage(cont, "NGsł","Config_XML2CSV");
      return false;
    }
    System.out.println("model.strRecordTag=" + model.getStrRecordTag());
    //XQuery쐬
    //XQueryConstructor xq = new XQueryConstructor();
    //XQueryModel xqmodel = xq.createXQuery(neoaccess.getXmlNodeList(txtXmlRoot.getText()),model.lstFields,model.getStrRecordTag());
    XQueryModel xqmodel = createXQuery(txtXmlRoot.getText(),model.lstFields,model.getStrRecordTag());
    //xqmodel.setLstCondition(lstCondition);
    Iterator it = lstCondition.iterator();
    while(it.hasNext()){
      xqmodel.addConditionModel((XQueryConditionModel)it.next());
    }
    xqmodel.setWhereFlag(rdoWhere.isSelected());
    xqmodel.setNewLineFlag(false);
    String query = xqmodel.getQuery();

    JTextField txf = new JTextField(20);
    Object[] message = {"XMLf[^̓Ǎw肵ĉ", txf };
    Object[] options = {"","XLbv","LZ"};
    int opn = JOptionPane.showOptionDialog(cont,
                                 message,
                                 "Ǎw",
                                 JOptionPane.YES_NO_CANCEL_OPTION,
                                 JOptionPane.INFORMATION_MESSAGE,
                                 null,
                                 options,
                                 "");
    if(opn == JOptionPane.YES_OPTION){
      int count = 0;
      try{
        count = Integer.parseInt(txf.getText());
      }catch(Exception ex){
      }
      if(count <= 0 || count > 1000){
        MessageDialog.showWarningMessage(cont,"1ȏ1000ȉ̒lw肵ĉ","Config_XML2CSV");
        return false;
      }
      if(!checkMultioccurrence(xqmodel,count,false)){
        return false;
      }else{
        model.lstFields = new ArrayList();
        for (int i = 0; i < tblmodel.getRowCount(); i++) {
          String[] str = new String[4];
          str[0] = tblmodel.getValueAt(i, 1).toString();
          str[1] = tblmodel.getValueAt(i, 2).toString();
          str[2] = tblmodel.getValueAt(i, 3).toString();
          str[3] = tblmodel.getValueAt(i, 4).toString();
          model.lstFields.add(str);
        }
        //xqmodel = xq.createXQuery(neoaccess.getXmlNodeList(txtXmlRoot.getText()),model.lstFields,model.getStrRecordTag());
        xqmodel = createXQuery(txtXmlRoot.getText(),model.lstFields,model.getStrRecordTag());
        //xqmodel.setLstCondition(lstCondition);
        Iterator it2 = lstCondition.iterator();
        while(it2.hasNext()){
          xqmodel.addConditionModel((XQueryConditionModel)it2.next());
        }
        xqmodel.setWhereFlag(rdoWhere.isSelected());
        xqmodel.setNewLineFlag(false);
        query = xqmodel.getQuery();
      }
    }else if(opn == JOptionPane.NO_OPTION){

    }else{
      return false;
    }
    //"<""&lt;"ɕϊ
    query = StringUtil.replaceAll(query,"<","&lt;");
    model.setQuery(query);
    model.lstConditions = lstCondition;
    model.setWhereFlag(this.rdoWhere.isSelected());

    return true;
  }

  /**
   * Ǎ{^NbN
   *
   * @param e ActionEvent
   */
  void btnRead_actionPerformed(ActionEvent e) {
    String id = "";

    Xml2CsvIdListDialog dlgIdList = showIdListDialog("`ꗗ");
    if (!dlgIdList.okFlag) {
      return;
    }
    Object obj = dlgIdList.getSelectedId();
    if (obj == null) {
      return;
    }
    else {
      id = obj.toString();
    }
    selectedId = id;

    //System.out.println("id=" + id);
    if(id.equals("")){
      MessageDialog.showWarningMessage(cont, "`IDIĉ","Config_XML2CSV");
    }
    //Xml2CsvNeoCoreAccess neoaccess = new Xml2CsvNeoCoreAccess();
    try{
      model = neoaccess.getConfigModel(id,"UTF-8");
      //model = neoaccess.getConfigModel(id,encoding);
    }catch(Exception ex){
      MessageDialog.showErrorMessage(cont, "`̓ǍɎs܂","Config_XML2CSV");
      return;
    }

    showXmlTree(neoaccess,model.getDocument());
    setControl();
    setMode(UPDATE_MODE);
    //this.txtConfigId.setEditable(false);
    //txtXmlRoot.setText("");

    lstCondition = model.lstConditions;
    if(lstCondition == null){
      lstCondition = new ArrayList();
    }

    condmodel = new DefaultComboBoxModel();
    lstCond.setModel(condmodel);

    setCondList(lstCondition,condmodel);
  }

  /**
   * XML\ǍA`Ǎ̃Rg[̐ݒs
   */
  private void setControl(){
    this.txtXmlRoot.setText(model.getDocument());
    this.txtConfigId.setText(model.getId());
    this.txtMemo.setText(model.getMemo());
    //this.txtHost.setText(model.host);
    //this.txtPort.setText(model.port);
    //this.txtUserId.setText(model.userid);
    //this.txtPassword.setText(model.password);
    //this.txtQuery.setText(model.query);
    this.txtBaseNode.setText(model.getStrRecordTag());

    if(model.isWhereFlag()){
      this.rdoWhere.setSelected(true);
    }else{
      this.rdoFor.setSelected(true);
    }

    //this.txtRecordTag.setText(model.strRecordTag);
    this.txtCsvFile.setText(model.getCsvfile());
    this.chkType.setSelected(model.typeFlag);
    this.lstmodel = new DefaultListModel();
    if(model.multioccurrence!=null){
      StringTokenizer st = new StringTokenizer(model.multioccurrence, ",");
      System.out.println("st=" + st);
      while (st.hasMoreTokens()) {
        String val = st.nextToken();
        lstmodel.addElement(val);
      }
    }
    //this.lstMulti.setModel(lstmodel);

    int i = 0;
    String[][] rowData = null;
    if(model.lstFields != null){
      java.util.List lstFields = model.lstFields;
      rowData = new String[lstFields.size()][5];
      Iterator it = lstFields.iterator();
      while (it.hasNext()) {
        String[] str = (String[]) it.next();
        rowData[i][0] = String.valueOf(i + 1);
        rowData[i][1] = str[0];
        rowData[i][2] = str[1];
        rowData[i][3] = str[2];
        rowData[i][4] = str[3];
        i++;
      }
    }
    tblmodel.setDataVector(rowData, tblColNames);
    jTable1.setModel(tblmodel);
    TableColumn col0 = jTable1.getColumnModel().getColumn(0);
    col0.setPreferredWidth(70);
    TableColumn col1 = jTable1.getColumnModel().getColumn(1);
    col1.setPreferredWidth(279);
    TableColumn col2 = jTable1.getColumnModel().getColumn(2);
    col2.setPreferredWidth(70);
    TableColumn col3 = jTable1.getColumnModel().getColumn(3);
    col3.setPreferredWidth(189);
    TableColumn col4 = jTable1.getColumnModel().getColumn(4);
    //if(i < 8){
    //	col4.setPreferredWidth(130);
    //}else{
    col4.setPreferredWidth(124);
    //}
  }

  /**
   * 폜{^NbN
   *
   * @param e ActionEvent
   */
  void btnDelete_actionPerformed(ActionEvent e) {
    if(JOptionPane.OK_OPTION!=MessageDialog.showConfirmMessage(cont, "폜܂H","Config_XML2CSV")){
      return;
    }
    String str = null;
    if(mode==UPDATE_MODE){
      str = neoaccess.deleteConfigXML(model.getId());
    }
    System.out.println("result = " + str);
    //showXmlTree(neoaccess,xmlroot);
    //model.clear();
    jTree1 = null;
    jScrollPane1.setViewportView(jTree1);
    model = new Xml2CsvConfigModel();
    //model.document = xmlroot;
    lstCondition = new ArrayList();
    setCondList(lstCondition,condmodel);
    setControl();
    setMode(INSERT_MODE);
    //this.txtConfigId.setEditable(true);
    setMode(INIT_MODE);
  }

  /**
   * {^NbN
   *
   * @param e ActionEvent
   */
  void btnClose_actionPerformed(ActionEvent e) {
  	dispose();
  }

  /**
   * փ{^NbN
   *
   * @param e ActionEvent
   */
  void btnUp_actionPerformed(ActionEvent e) {
    int row = jTable1.getSelectedRow();
    if(row == -1)
      return;
    if(row > 0){
      tblmodel.moveRow(row,row,row-1);
      jTable1.setRowSelectionInterval(row-1,row-1);
    }
    JViewport jv = jScrollPane2.getViewport();
    int rowH = (int)jTable1.getCellRect(row-1,1,true).getHeight();
    int rowY = (int)jTable1.getCellRect(row-1,1,true).getY();
    int viewH = (int)jv.getExtentSize().getHeight();
    int viewY = (int)jv.getViewPosition().getY();
    //System.out.println("rowH=" + rowH);
    //System.out.println("rowY=" + rowY);
    //System.out.println("viewH=" + viewH);
    if(rowY < viewY)
      jv.setViewPosition(new Point(0,(rowY)));
    setTableNumber();
  }

  /**
   * փ{^NbN
   *
   * @param e ActionEvent
   */
  void btnDown_actionPerformed(ActionEvent e) {
    int row = jTable1.getSelectedRow();
    if(row == -1)
      return;
    if (row < jTable1.getRowCount() - 1) {
      tblmodel.moveRow(row, row, row + 1);
      jTable1.setRowSelectionInterval(row + 1, row + 1);
    }
    JViewport jv = jScrollPane2.getViewport();
    int rowH = (int)jTable1.getCellRect(row+1,1,true).getHeight();
    int rowY = (int)jTable1.getCellRect(row+1,1,true).getY();
    int viewH = (int)jv.getExtentSize().getHeight();
    int viewY = (int)jv.getViewPosition().getY();
    //System.out.println("rowH=" + rowH);
    //System.out.println("rowY=" + rowY);
    //System.out.println("viewH=" + viewH);
    //System.out.println("viewY=" + viewY);
    if(rowY+rowH > viewY+viewH)
      jv.setViewPosition(new Point(0,(rowY+rowH-viewH)));
    setTableNumber();
  }

  /**
   * 폜{^NbN
   *
   * @param e ActionEvent
   */
  void btnDel_actionPerformed(ActionEvent e) {
    int row = jTable1.getSelectedRow();
    if(row != -1){
      tblmodel.removeRow(row);
      if(row < jTable1.getRowCount()){
        jTable1.setRowSelectionInterval(row,row);
      }else{
        if(jTable1.getRowCount()!=0)
          jTable1.setRowSelectionInterval(row-1,row-1);
      }
      //jTable1.setRowSelectionInterval(row+1,row+1);
    }
    setTableNumber();
  }

  /**
   * `̒`ݒ肷
   */
  private void setTableNumber(){
    for(int i=0;i<tblmodel.getRowCount();i++){
      tblmodel.setValueAt(String.valueOf(i+1),i,0);
    }
  }

  /**
   * ǉ{^NbN
   *
   * @param e ActionEvent
   */
  void btnAdd_actionPerformed(ActionEvent e) {
    TreePath tp = jTree1.getSelectionPath();
    if(tp == null){
      MessageDialog.showInformationMessage(cont,"XML^OIĉ","Config_XML2CSV");
    }else{
      String strLastNode = getLastNode(tp);
      //String strNode = getNodePath(tp,"/");
      String strNode = XmlNodeUtil.ConvertRelativePath(getNodePath(tp,"/"),model.getStrRecordTag());
      if(strLastNode==null){
        MessageDialog.showInformationMessage(cont,"ȊO̎qvf^O͎wł܂","Config_XML2CSV");
        return;
      }

      Xml2CsvMappingDialog dlgMapping = showMappingDialog("ǉ",strNode,"",strLastNode.replace('@','_'),"");
      if(!dlgMapping.okFlag){
        return;
      }

      String[] str = {"",strNode,dlgMapping.getIndex(),dlgMapping.getCsv(),dlgMapping.getType()};
      tblmodel.addRow(str);
      int row = jTable1.getRowCount();
      //System.out.println("row=" + row);
      jTable1.setRowSelectionInterval(row - 1, row - 1);
      JViewport jv = jScrollPane2.getViewport();
      int rowH = (int) jTable1.getCellRect(row - 1, 1, true).getHeight();
      int rowY = (int) jTable1.getCellRect(row - 1, 1, true).getY();
      int viewH = (int) jv.getExtentSize().getHeight();
      int viewY = (int) jv.getViewPosition().getY();
      //System.out.println("rowH=" + rowH);
      //System.out.println("rowY=" + rowY);
      //System.out.println("viewH=" + viewH);
      //System.out.println("viewY=" + viewY);
      if(rowY+rowH  > viewY+viewH){
        //System.out.println("rowY + rowH - viewH=" + String.valueOf(rowY + rowH - viewH));
        jv.setViewPosition(new Point(0, (rowY + rowH - viewH)));
        jv.setViewPosition(new Point(0, (rowY + rowH - viewH)));
      }
      setTableNumber();
    }
  }

  /**
   * }{^NbN
   *
   * @param e ActionEvent
   */
  void btnIns_actionPerformed(ActionEvent e) {
    TreePath tp = jTree1.getSelectionPath();
    if (tp == null) {
      MessageDialog.showInformationMessage(cont,"XML^OIĉ","Config_XML2CSV");
    }
    else {
      String strLastNode = getLastNode(tp);
      //String strNode = getNodePath(tp,"/");
      String strNode = XmlNodeUtil.ConvertRelativePath(getNodePath(tp,"/"),model.getStrRecordTag());
      if(strLastNode==null){
        MessageDialog.showInformationMessage(cont,"ȊO̎qvf^O͎wł܂","Config_XML2CSV");
        return;
      }
      int row = jTable1.getSelectedRow();
      if (row != -1) {
        Xml2CsvMappingDialog dlgMapping = showMappingDialog("}",strNode,"",strLastNode.replace('@','_'),"");
        if(!dlgMapping.okFlag){
          return;
        }
        String[] str = {
            "", strNode,dlgMapping.getIndex(), dlgMapping.getCsv(), dlgMapping.getType()};
        tblmodel.insertRow(row, str);
        jTable1.setRowSelectionInterval(row, row);
        /*JViewport jv = jScrollPane2.getViewport();
        int rowH = (int) jTable1.getCellRect(row - 1, 1, true).getHeight();
        int rowY = (int) jTable1.getCellRect(row - 1, 1, true).getY();
        int viewH = (int) jv.getExtentSize().getHeight();
        int viewY = (int) jv.getViewPosition().getY();
        if(rowY+rowH  > viewY+viewH){
          System.out.println("rowY + rowH - viewH=" + String.valueOf(rowY + rowH - viewH));
          jv.setViewPosition(new Point(0, (rowY + rowH - viewH)));
          jv.setViewPosition(new Point(0, (rowY + rowH - viewH)));
        }*/
        setTableNumber();
      }
    }
  }

  /**
   * w肳ꂽTreePathŌ̃m[h擾
   *
   * @param tp TreePath
   * @return String
   */
  private String getLastNode(TreePath tp){
    Object[] obj = tp.getPath();
    //for(int i=0;i<obj.length;i++){
      //System.out.println("obj=" + obj[i]);
    //}
    DefaultMutableTreeNode lastNode = (DefaultMutableTreeNode)tp.getLastPathComponent();
    //System.out.println("lastNode=" + lastNode.getChildCount());
    int lenNode = obj.length;
    String strNode = null;
    if(lastNode.getChildCount()==0){
      strNode = obj[lenNode-1].toString();
      if(strNode.startsWith("@")){
        strNode = obj[lenNode-2].toString() + strNode;
      }
    }else{
      boolean flag = true;
      for(int i=0;i<lastNode.getChildCount();i++){
        if(!lastNode.getChildAt(i).toString().startsWith("@")){
          flag = false;
          break;
        }
      }
      if(flag){
        strNode = obj[lenNode-1].toString();
      }
    }
    return strNode;
  }

  /**
   * w肳ꂽTreePath̐΃pXԂ
   *
   * @param tp TreePath
   * @param deimiter ؂蕶
   * @return ΃pX
   */
  private String getNodePath(TreePath tp,String deimiter){
    Object[] obj = tp.getPath();
    String str = "";
    for(int i=0;i<obj.length;i++){
      //System.out.println("obj=" + obj[i]);
      str = str + deimiter + obj[i].toString();
    }
    return str;
  }

  /**
   * }bsO`_CAO\
   *
   * @param title EBhE^Cg
   * @param strNode m[h
   * @param strIndex INDEX
   * @param strCsv CSVtB[h
   * @param strType CSVtB[h^Cv
   * @return Xml2CsvMappingDialog
   */
  private Xml2CsvMappingDialog showMappingDialog(String title,String strNode,String strIndex,String strCsv,String strType){
    Xml2CsvMappingDialog dlgMapping = new Xml2CsvMappingDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlgMapping,500,220);
    dlgMapping.setXmltag(strNode);
    //m[h΃pXɕϊ
    String tmp = XmlNodeUtil.ConvertAbsolutePath(strNode,model.getStrRecordTag());
    if(strNode.indexOf("@")!=-1){
      tmp = tmp.substring(0,tmp.indexOf("@")-1);
    }
    //m[h̑܂͊m[h̏ʑ̏ꍇINDEX͐ݒs
    if(model.getStrRecordTag().startsWith(tmp)){
      dlgMapping.setIndexEnable(false);
    }else{
      dlgMapping.setIndex(strIndex);
    }
    dlgMapping.setCsv(strCsv);
    dlgMapping.setCsvFieldType(csvfieldtype);
    dlgMapping.setType(strType);
    dlgMapping.setTypeFlag(chkType.isSelected());
    dlgMapping.tblmodel = tblmodel;
    dlgMapping.setVisible(true);
    return dlgMapping;
  }

  /**
   * `IDꗗ_CAO\
   *
   * @param title EBhE^Cg
   * @return Xml2CsvIdListDialog
   */
  private Xml2CsvIdListDialog showIdListDialog(String title){
    Xml2CsvIdListDialog dlgIdList = new Xml2CsvIdListDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlgIdList,500,300);
    java.util.List lds = neoaccess.getConfigIdMemoList();
    dlgIdList.setIdList(lds);
    dlgIdList.setVisible(true);
    return dlgIdList;
  }

  /**
   * ڑ_CAO\
   *
   * @param title EBhE^Cg
   * @return Xml2CsvConnectionDialog
   */
  private Xml2CsvConnectionDialog showConnectionDialog(String title){
    Xml2CsvConnectionDialog dlgConn = new Xml2CsvConnectionDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlgConn,400,220);
    dlgConn.setHost(model.getHost());
    dlgConn.setPort(model.getPort());
    dlgConn.setUserId(model.getUserid());
    dlgConn.setPassword(model.getPassword());
    dlgConn.setVisible(true);
    return dlgConn;
  }

  /**
   * ݒ_CAO\
   *
   * @param title EBhE^Cg
   * @param strNode m[h
   * @return Xml2CsvIdListDialog
   */
  private Xml2CsvConditionDialog showConditionDialog(String title,String strNode){
    Xml2CsvConditionDialog dlgCond = new Xml2CsvConditionDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlgCond,600,200);
    dlgCond.setNode(XmlNodeUtil.ConvertRelativePath(strNode,model.getStrRecordTag()));
    if(condmodel.getSize()==0)
      dlgCond.getCmbAndOr().setEnabled(false);
    dlgCond.setVisible(true);
    return dlgCond;
  }

  /**
   * XQuery_CAO\
   *
   * @param title EBhE^Cg
   * @param query NG
   * @return Xml2CsvIdListDialog
   */
  private Xml2CsvXQueryDialog showXQueryDialog(String title,String query){
    Xml2CsvXQueryDialog dlgQuery = new Xml2CsvXQueryDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlgQuery,500,330);
    dlgQuery.setQuerysize(querysize);
    dlgQuery.setXquery(query);
    dlgQuery.setVisible(true);
    return dlgQuery;
  }

  /**
   * }`IJX_CAO\
   *
   * @param title EBhE^Cg
   * @param model DefaultComboBoxModel
   * @return Xml2CsvIdListDialog
   */
  private Xml2CsvMultioccurrenceDialog showMultioccurrenceDialog(String title,java.util.List lst){
    Xml2CsvMultioccurrenceDialog dlgMulti = new Xml2CsvMultioccurrenceDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlgMulti,500,340);
    //for(int i=0;i<model.getSize();i++){
      //dlgMulti.model.addElement(model.getElementAt(i));
    //}
    dlgMulti.setModel(tblmodel);
    dlgMulti.setLstIndex(lst);
    //dlgMulti.setMultiflag(multiflag);
    dlgMulti.setVisible(true);
    return dlgMulti;
  }

  /**
   * XMLhLgꗗ_CAO\
   *
   * @param title EBhE^Cg
   * @return Xml2CsvIdListDialog
   */
  private Xml2CsvDocumentListDialog showDocumentListDialog(String title,DefaultComboBoxModel docModel){
    Xml2CsvDocumentListDialog dlg = new Xml2CsvDocumentListDialog(this,title,true);
    //_CAOʒɕ\
    GuiUtil.setCenterLocation(dlg,400,300);
    dlg.setListData(docModel);
    dlg.setVisible(true);
    return dlg;
  }

  /**
   * XV{^NbN
   *
   * @param e ActionEvent
   */
  void btnUpd_actionPerformed(ActionEvent e) {
    int row = jTable1.getSelectedRow();
    if(row != -1){
      Xml2CsvMappingDialog dlgMapping = showMappingDialog("XV",tblmodel.getValueAt(row,1).toString(),tblmodel.getValueAt(row,2).toString(),tblmodel.getValueAt(row,3).toString(),tblmodel.getValueAt(row,4).toString());
      if(!dlgMapping.okFlag){
        return;
      }
      tblmodel.setValueAt(dlgMapping.getIndex(),row,2);
      tblmodel.setValueAt(dlgMapping.getCsv(),row,3);
      tblmodel.setValueAt(dlgMapping.getType(),row,4);
    }
    //setTableNumber();
  }

  class Xml2CsvCellRenderer extends JLabel implements TableCellRenderer {
    private Color c = Color.black;
    public void setCellColor(Color c) {
      this.c = c;
    }
    public Component getTableCellRendererComponent(
        JTable table, Object data, boolean isSelected, boolean hasFocus,
        int row, int column) {

      //setOpaque(true); /* wiF񓧖ɂ */

      /* */
      if (column == 4) {
        setBackground(Color.white);
        setForeground(c);
      }else{
        setBackground(Color.white);
        setForeground(Color.black);
      }
      setText(data.toString());

      return this;
    }
  }

  void chkType_itemStateChanged(ItemEvent e) {
    if (e.getStateChange() == ItemEvent.SELECTED) {
      cellrenderer.setCellColor(Color.black);
    }
    else if (e.getStateChange() == ItemEvent.DESELECTED) {
      cellrenderer.setCellColor(Color.gray);
    }
  }

  /**
   * ڑ{^NbN̏
   * ڑ_CAO\
   *
   * @param e ActionEvent
   */
  void btnConn_actionPerformed(ActionEvent e) {
    Xml2CsvConnectionDialog dlgConn = showConnectionDialog("ڑ");
    if(!dlgConn.okFlag){
      return;
    }
    model.setHost(dlgConn.getHost());
    model.setPort(dlgConn.getPort());
    model.setUserid(dlgConn.getUserId());
    model.setPassword(dlgConn.getPassword());
  }

  /**
   * ǉ
   *
   * @param e ActionEvent
   */
  void btnMultiAdd_actionPerformed(ActionEvent e) {
    TreePath tp = jTree1.getSelectionPath();
    if(tp == null){
      MessageDialog.showInformationMessage(cont,"XML^OIĉ","Config_XML2CSV");
    }else{
      String strLastNode = getLastNode(tp);
      String strNode = getNodePath(tp, "/");
      if (strLastNode == null) {
        MessageDialog.showInformationMessage(cont,"XML^OIĉ","Config_XML2CSV");
        return;
      }
      //System.out.println("strLastNode="+strLastNode);

      Xml2CsvConditionDialog dlgCond = showConditionDialog("ݒ",strNode);
      if(!dlgCond.okFlag){
        return;
      }
      /*
      XQueryConditionModel qcmodel = new XQueryConditionModel();
      qcmodel.setAndor(dlgCond.getCmbAndOr().getSelectedItem().toString());
      String andor =  qcmodel.getAndor();
      if(andor.equals("")){
        andor = "   ";
      }
      andor = andor + " ";
      qcmodel.setNode(dlgCond.getTxtNode().getText());
      qcmodel.setFunc(dlgCond.getCmbFunc().getSelectedItem().toString());
      qcmodel.setEq(dlgCond.getCmbEq().getSelectedItem().toString());
      qcmodel.setValue(dlgCond.getTxtValue().getText());*/
      try{
        XQueryConditionModel qcmodel = new XQueryConditionModel(dlgCond.getCmbAndOr().getSelectedItem().toString(),
            dlgCond.getTxtNode().getText(),
            dlgCond.getCmbFunc().getSelectedItem().toString(),
            dlgCond.getCmbEq().getSelectedItem().toString(),
            dlgCond.getTxtValue().getText());
        lstCondition.add(qcmodel);
        setCondList(lstCondition,condmodel);
      }catch(Exception ex){
        ex.printStackTrace();
      }
    }
  }

  /**
   * 폜
   *
   * @param e ActionEvent
   */
  void btnMultiDel_actionPerformed(ActionEvent e) {
    int row = lstCond.getSelectedIndex();
    //System.out.println("row="+row);
    if(row != -1){
      //condmodel.removeElementAt(row);
      //lstmodel.remove(row);
      lstCondition.remove(row);
      /*if(lstCondition.size() > 0){
        XQueryConditionModel qcmodel = (XQueryConditionModel)lstCondition.get(0);
        qcmodel.setAndor("");
      }*/
      setCondList(lstCondition,condmodel);
    }
  }

  /**
   * w肳ꂽDefaultComboBoxModelɐݒ肷
   *
   * @param lst List
   * @param model DefaultComboBoxModel
   */
  private void setCondList(java.util.List lst,DefaultComboBoxModel model){
    model.removeAllElements();
    Iterator it = lst.iterator();
    while(it.hasNext()){
      XQueryConditionModel qcmodel = (XQueryConditionModel)it.next();
      String andor =  qcmodel.getAndor();
      if(andor.equals("")){
        andor = "   ";
      }
      andor = andor + " ";
      model.addElement(andor + qcmodel.getConditionStr(false));
    }
  }

  /**
   * XQuery쐬{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnQuery_actionPerformed(ActionEvent e) {
    if(tblmodel.getRowCount() == 0){
      MessageDialog.showWarningMessage(cont,"`w肵ĉ","Config_XML2CSV");
      return;
    }
    model.lstFields = new ArrayList();
    for (int i = 0; i < tblmodel.getRowCount(); i++) {
      String[] str = new String[4];
      str[0] = tblmodel.getValueAt(i, 1).toString();
      str[1] = tblmodel.getValueAt(i, 2).toString();
      str[2] = tblmodel.getValueAt(i, 3).toString();
      str[3] = tblmodel.getValueAt(i, 4).toString();
      model.lstFields.add(str);
    }

    //XQueryConstructor xq = new XQueryConstructor();
    //XQueryModel xqmodel = xq.createXQuery(neoaccess.getXmlNodeList(txtXmlRoot.getText()),model.lstFields,model.getStrRecordTag());
    XQueryModel xqmodel = createXQuery(txtXmlRoot.getText(),model.lstFields,model.getStrRecordTag());
    //xqmodel.setLstCondition(lstCondition);
    Iterator it = lstCondition.iterator();
    while(it.hasNext()){
      xqmodel.addConditionModel((XQueryConditionModel)it.next());
    }
    xqmodel.setWhereFlag(rdoWhere.isSelected());
    String query = xqmodel.getQuery();

    JTextField txf = new JTextField(20);
    Object[] message = {"XMLf[^̓Ǎw肵ĉ", txf };
    Object[] options = {"","XLbv","LZ"};
    int opn = JOptionPane.showOptionDialog(cont,
                                 message,
                                 "Ǎw",
                                 JOptionPane.YES_NO_CANCEL_OPTION,
                                 JOptionPane.INFORMATION_MESSAGE,
                                 null,
                                 options,
                                 "");
    if(opn == JOptionPane.YES_OPTION){
      int count = 0;
      try{
        count = Integer.parseInt(txf.getText());
      }catch(Exception ex){
      }
      if(count <= 0 || count > 1000){
        MessageDialog.showWarningMessage(cont,"1ȏ1000ȉ̒lw肵ĉ","Config_XML2CSV");
        return;
      }
      if(!checkMultioccurrence(xqmodel,count,false)){
        return;
      }else{
        model.lstFields = new ArrayList();
        for (int i = 0; i < tblmodel.getRowCount(); i++) {
          String[] str = new String[4];
          str[0] = tblmodel.getValueAt(i, 1).toString();
          str[1] = tblmodel.getValueAt(i, 2).toString();
          str[2] = tblmodel.getValueAt(i, 3).toString();
          str[3] = tblmodel.getValueAt(i, 4).toString();
          model.lstFields.add(str);
        }
        //xqmodel = xq.createXQuery(neoaccess.getXmlNodeList(txtXmlRoot.getText()),model.lstFields,model.getStrRecordTag());
        xqmodel = createXQuery(txtXmlRoot.getText(),model.lstFields,model.getStrRecordTag());
        //xqmodel.setLstCondition(lstCondition);
        Iterator it2 = lstCondition.iterator();
        while(it2.hasNext()){
          xqmodel.addConditionModel((XQueryConditionModel)it2.next());
        }
        xqmodel.setWhereFlag(rdoWhere.isSelected());
        query = xqmodel.getQuery();
      }
    }else if(opn == JOptionPane.NO_OPTION){

    }else{
      return;
    }

    System.out.println("**********XQuery**********");
    System.out.println(query);
    System.out.println("**********XQuery**********");
    this.showXQueryDialog("XQuery",query);

    //XQueryConstructor();
  }

  /**
   * XQuery쐬
   *
   * @param docroot hLg[g
   * @param lst `
   * @param record m[h
   * @return XQueryModel
   */
  private XQueryModel createXQuery(String docroot,java.util.List lst,String record){
    XQueryConstructor xq = new XQueryConstructor();
    java.util.List lstParam = new ArrayList();
    Iterator it = lst.iterator();
    FieldModel[] aryModel = new FieldModel[lst.size()];
    //while(it.hasNext()){
    for(int i=0;i<aryModel.length;i++){
      String[] str = (String[])it.next();
      //FieldModel fmodel = new FieldModel();
      //fmodel.setNode(str[0]);
      //fmodel.setIndex(str[1]);
      //fmodel.setName(str[2]);
      //FieldModel fmodel = new FieldModel(str[0],str[1],str[2]);
      //lstParam.add(fmodel);
      try{
        aryModel[i] = new FieldModel(str[0], str[1], str[2]);
      }catch(Exception e){
        e.printStackTrace();
      }
    }
    //XQueryModel xmodel = xq.createXQuery(neoaccess.getXmlNodeList(docroot),lstParam,record);
    XQueryModel xmodel = xq.createXQuery(neoaccess.getXmlNodeArray(docroot),aryModel,record);
    xmodel.setNewLineFlag(true);
    //xmodel.setReturnTag("record");
    return xmodel;
  }
  /**
   * XMLf[^ǂݍŃ}`IJX̃`FbNs
   *
   * @param xqmodel XQueryModel
   * @param cnt Ǎ
   * @param mflag boolean
   * @return boolean
   */
  private boolean checkMultioccurrence(XQueryModel xqmodel,int cnt,boolean mflag){
    boolean ret = true;
    String query2 = "";
    String strFor = "";
    String strReturn = "";
    String posquery = "[position()>=1 and position()<=" + String.valueOf(cnt) +
        "]";
    StringBuffer sb = new StringBuffer();
    //Iterator it = xqmodel.getLstFor().iterator();
    //while (it.hasNext()) {
    for(int i=0;i<xqmodel.getForModelCount();i++){
      //XQueryForModel model = (XQueryForModel) it.next();
      XQueryForModel model = xqmodel.getForModel(i);
      sb.append("for ");
      sb.append(model.getVariable());
      sb.append(" in ");
      sb.append(model.getNode());
      if (model.getVariable().equals("$rec")) {
        sb.append(posquery);
      }
      sb.append(" ");
    }
    strFor = sb.toString();
    //System.out.println("strFor=" + strFor);

    int start = 0;
    //boolean[] multiflag = new boolean[xqmodel.getLstReturn().size()];
    boolean[] multiflag = new boolean[xqmodel.getReturnModelCount()];
    for(int k=0;k<multiflag.length;k++){
      multiflag[k]=false;
    }
    //for(int i=0;i<xqmodel.getLstReturn().size();i++) {
    for(int i=0;i<xqmodel.getReturnModelCount();i++) {
      //XQueryReturnModel model = (XQueryReturnModel)xqmodel.getLstReturn().get(i);
      XQueryReturnModel model = xqmodel.getReturnModel(i);
      if((i%10)==0){
        sb = new StringBuffer();
        sb.append("return <result>");
      }else{
        sb.append(",");
      }
      sb.append("{count(");
      sb.append(model.getNode());
      sb.append(")}");
      //sb.append("\n");
      //if((i%10)==9 || i==xqmodel.getLstReturn().size()-1){
      if((i%10)==9 || i==xqmodel.getReturnModelCount()-1){
        sb.append("</result>");
        strReturn = sb.toString();
        //System.out.println("strReturn=" + strReturn);
        try{
          String result = neoaccess.queryXML(strFor + strReturn);
          //System.out.println("result=" + result);
          DomAccess dom = new DomAccess();
          Document doc = dom.parseString(result);
          Element elm = doc.getDocumentElement();
          NodeList lstCount = elm.getElementsByTagName("result");
          int numCond = lstCount.getLength();
          for (int m = 0; m < numCond; m++) {
            Element elmVal = (Element) lstCount.item(m);
            String str = elmVal.getChildNodes().item(0).getNodeValue();
            //System.out.println("str=" + str);
            StringTokenizer st = new StringTokenizer(str,",");
            int idx = 0;
            while(st.hasMoreTokens()){
              String tmp = st.nextToken();
              if(Integer.parseInt(tmp)>1){
                multiflag[start*10 + idx]=true;
              }
              idx++;
            }
          }
          start++;
        }catch(Exception e){
          e.printStackTrace();
        }
      }
    }
    //for(int k=0;k<multiflag.length;k++){
      //System.out.println("multiflag[k]=" + multiflag[k]);
    //}
    java.util.List lst = new ArrayList();
    DefaultComboBoxModel multimodel = new DefaultComboBoxModel();
    for(int i=0;i<multiflag.length;i++){
      //System.out.println("multiflag["+i+"]="+multiflag[i]);
      if(multiflag[i]){
        String[] str = (String[])model.lstFields.get(i);
        //System.out.println("str[0]="+str[0]);
        multimodel.addElement(str[0]);
        lst.add(String.valueOf(i));
      }
    }
    //if(multimodel.getSize()>0 || mflag){
    if(multimodel.getSize()>0){
      Xml2CsvMultioccurrenceDialog dlg = showMultioccurrenceDialog("}`IJX",lst);
      ret = dlg.okFlag;
      if(dlg.getMmodel().getRowCount()==0){
        if(mflag){
          MessageDialog.showInformationMessage(cont,"}`IJX̃m[h݂͑Ă܂","Config_XML2CSV");
        }
      }
    }else{
      if(mflag){
        MessageDialog.showInformationMessage(cont,"}`IJX̃m[h݂͑Ă܂","Config_XML2CSV");
      }
    }

    return ret;
  }

  /**
   * XMLc[̃}EX
   * ENbNŃ|bvAbvj[\
   *
   * @param e MouseEvent
   */
  void jTree1_mousePressed(MouseEvent e) {
    int row = jTree1.getClosestRowForLocation(e.getX(), e.getY());
    jTree1.setSelectionInterval(row, row);
    if (e.isPopupTrigger()) {
      /* JPopupMenu\ */
      popup.show(e.getComponent(), e.getX(), e.getY());
    }
  }
  /**
   * XMLc[̃}EX
   * ENbNŃ|bvAbvj[\
   *
   * @param e MouseEvent
   */
  void jTree1_mouseReleased(MouseEvent e) {
    if (e.isPopupTrigger()) {
      /* JPopupMenu\ */
      popup.show(e.getComponent(), e.getX(), e.getY());
    }
  }

  /**
   * |bvAbvj[Ȉ
   *
   * @param e ActionEvent
   */
  void menuItem1_actionPerformed(ActionEvent e) {
    btnMultiAdd_actionPerformed(e);
  }
  /**
   * |bvAbvj[Ȉ
   *
   * @param e ActionEvent
   */
  void menuItem2_actionPerformed(ActionEvent e) {
    btnAdd_actionPerformed(e);
  }
  /**
   * |bvAbvj[Ȉ
   *
   * @param e ActionEvent
   */
  void menuItem3_actionPerformed(ActionEvent e) {
    btnBaseNode_actionPerformed(e);
  }

  /**
   * }`IJX{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnMulti_actionPerformed(ActionEvent e) {
    if(tblmodel.getRowCount() == 0){
      MessageDialog.showWarningMessage(cont,"`w肵ĉ","Config_XML2CSV");
      return;
    }
    String msg = MessageDialog.showInputMessage(cont, "XMLf[^̓Ǎw肵ĉ","Ǎw");
    //System.out.println(msg);
    if(msg == null){
      return;
    }
    int count = 0;
    try{
      count = Integer.parseInt(msg);
    }catch(Exception ex){
    }
    if(count <= 0 || count > 1000){
      MessageDialog.showWarningMessage(cont,"1ȏ1000ȉ̒lw肵ĉ","Config_XML2CSV");
      return;
    }
    model.lstFields = new ArrayList();
    for (int i = 0; i < tblmodel.getRowCount(); i++) {
      String[] str = new String[4];
      str[0] = tblmodel.getValueAt(i, 1).toString();
      str[1] = tblmodel.getValueAt(i, 2).toString();
      str[2] = tblmodel.getValueAt(i, 3).toString();
      str[3] = tblmodel.getValueAt(i, 4).toString();
      model.lstFields.add(str);
    }

    //XQueryConstructor xq = new XQueryConstructor();
    //XQueryModel xqmodel = xq.createXQuery(neoaccess.getXmlNodeList(txtXmlRoot.getText()),model.lstFields,model.getStrRecordTag());
    XQueryModel xqmodel = createXQuery(txtXmlRoot.getText(),model.lstFields,model.getStrRecordTag());

    if (!checkMultioccurrence(xqmodel, count, true)) {
      return;
    }
    //if(!checkMultioccurrence(query,model.lstFields,count,true)){
    //  return;
    //}

  }

  /**
   * m[hݒ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnBaseNode_actionPerformed(ActionEvent e) {
    TreePath tp = jTree1.getSelectionPath();
    if(tp == null){
      MessageDialog.showInformationMessage(cont,"m[hIĉ","Config_XML2CSV");
    }else{
      String strLastNode = getLastNode(tp);
      String strNode = getNodePath(tp, "/");
      //System.out.println("strNode=" + strNode);
      if (strNode.equals("/ND")) {
        MessageDialog.showInformationMessage(cont, "ND͑Ił܂", "Config_XML2CSV");
        return;
      }
      if (strNode.substring(strNode.lastIndexOf("/")+1).startsWith("@")) {
        MessageDialog.showInformationMessage(cont, "͑Ił܂", "Config_XML2CSV");
        return;
      }
      //System.out.println("strLastNode=" + strLastNode);
      if(JOptionPane.OK_OPTION!=MessageDialog.showConfirmMessage(cont, "m[h" + strNode + "ɕύX܂H","Config_XML2CSV")){
        return;
      }
      String path = "";
      //`̃m[hĐݒ
      for(int i=0;i<tblmodel.getRowCount();i++){
        path = tblmodel.getValueAt(i,1).toString();
        //System.out.println("path1=" + path);
        path = XmlNodeUtil.ConvertAbsolutePath(path,model.getStrRecordTag());
        //System.out.println("path2=" + path);
        path = XmlNodeUtil.ConvertRelativePath(path,strNode);
        //System.out.println("path3=" + path);
        tblmodel.setValueAt(path,i,1);

        if(tblmodel.getValueAt(i,1).toString().equals(".") ||
           tblmodel.getValueAt(i,1).toString().startsWith("./@") ||
           tblmodel.getValueAt(i,1).toString().indexOf("../@")!=-1){
          tblmodel.setValueAt("",i,2);
        }
      }
      //̃m[hĐݒ
      Iterator it = lstCondition.iterator();
      while(it.hasNext()){
        XQueryConditionModel qcmodel = (XQueryConditionModel)it.next();
        path = XmlNodeUtil.ConvertAbsolutePath(qcmodel.getNode(),model.getStrRecordTag());
        System.out.println("path2=" + path);
        path = XmlNodeUtil.ConvertRelativePath(path,strNode);
        System.out.println("path3=" + path);
        try{
          qcmodel.setNode(path);
        }catch(Exception ex){
          ex.printStackTrace();
        }
      }
      setCondList(lstCondition,condmodel);

      //m[hݒ
      model.setStrRecordTag(strNode);
      txtBaseNode.setText(model.getStrRecordTag());
    }
  }

  /**
   * `Tablẽ_uNbN̏
   *
   * @param e MouseEvent
   */
  void jTable1_mousePressed(MouseEvent e) {
    if(e.getClickCount()==2){
      btnUpd.doClick();
    }
  }
}


class ConfigXml2CsvMainFrame_jMenuFileExit_ActionAdapter implements ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_jMenuFileExit_ActionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_jMenuHelpAbout_ActionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class Xml2CsvFilter extends FileFilter{
  public boolean accept(File f){
    String name=f.getName();
    return(name.endsWith(".xml"));
  }
  public String getDescription(){
    return "*.xml";
  }
}

class ConfigXml2CsvMainFrame_btnNew_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnNew_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnNew_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnFileSave_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnFileSave_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnFileSave_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnRead_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnRead_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnRead_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnSave_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnSave_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnSave_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnClose_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnClose_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
	this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
	adaptee.btnClose_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnUp_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnUp_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
	this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
	adaptee.btnUp_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnDown_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnDown_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
	this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
	adaptee.btnDown_actionPerformed(e);
  }
}

class Xml2CsvTableModel extends DefaultTableModel{
  public boolean isCellEditable(int rowIndex, int colIndex){
    return false;
  }
}

class ConfigXml2CsvMainFrame_btnDel_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnDel_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnDel_actionPerformed(e);
  }
}

class Xml2CsvTreeSelectionListener implements TreeSelectionListener {
  public void valueChanged(TreeSelectionEvent e){
    JTree tree = (JTree)e.getSource();
    DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();

    if (node != null){
      String selNode = (String)node.getUserObject();
      //System.out.println(selNode);
      if(selNode.startsWith("@")){
        DefaultMutableTreeNode parent = (DefaultMutableTreeNode)node.getParent();
        selNode = (String)parent.getUserObject() + selNode;
      }
      //System.out.println("selNode = " + selNode);
    }
  }
}

class ConfigXml2CsvMainFrame_btnAdd_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnAdd_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnAdd_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnIns_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnIns_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnIns_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnUpd_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnUpd_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnUpd_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnDelete_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnDelete_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnDelete_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_chkType_itemAdapter implements java.awt.event.ItemListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_chkType_itemAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.chkType_itemStateChanged(e);
  }
}

class ConfigXml2CsvMainFrame_btnConn_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnConn_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnConn_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnMultiAdd_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnMultiAdd_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnMultiAdd_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnMultiDel_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnMultiDel_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnMultiDel_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnQuery_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnQuery_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnQuery_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_jTree1_mouseAdapter extends java.awt.event.MouseAdapter {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_jTree1_mouseAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.jTree1_mousePressed(e);
  }
  public void mouseReleased(MouseEvent e) {
    adaptee.jTree1_mouseReleased(e);
  }
}


class ConfigXml2CsvMainFrame_menuItem1_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_menuItem1_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.menuItem1_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_menuItem2_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_menuItem2_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.menuItem2_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_menuItem3_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_menuItem3_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.menuItem3_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnMulti_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnMulti_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnMulti_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_btnBaseNode_actionAdapter implements java.awt.event.ActionListener {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_btnBaseNode_actionAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnBaseNode_actionPerformed(e);
  }
}

class ConfigXml2CsvMainFrame_jTable1_mouseAdapter extends java.awt.event.MouseAdapter {
  ConfigXml2CsvMainFrame adaptee;

  ConfigXml2CsvMainFrame_jTable1_mouseAdapter(ConfigXml2CsvMainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.jTable1_mousePressed(e);
  }
}

