package mki.xml2csv.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Config_XML2CSVڑݒDialog
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvConnectionDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JTextField txtPort = new JTextField();
  private JTextField txtHost = new JTextField();
  private JLabel lblType = new JLabel();
  private JLabel lblCsv = new JLabel();
  private JLabel lblIndex = new JLabel();
  private JPanel jPanel3 = new JPanel();
  private GridLayout gridLayout1 = new GridLayout();
  private JPanel jPanel1 = new JPanel();
  private JLabel lblXml = new JLabel();
  private JTextField txtUserId = new JTextField();
  private GridLayout gridLayout2 = new GridLayout();
  private JPanel jPanel2 = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  //JPasswordField txtPassword = new JPasswordField();
  private JTextField txtPassword = new JTextField();
  private JButton btnCancel = new JButton();
  private JButton btnOk = new JButton();
  /**
   * OK{^NbNꂽꍇtrueԂ
   */
  public boolean okFlag = false;

  /**
   * pX[hGetter
   *
   * @return String
   */
  public String getPassword() {
    //return txtPassword.getPassword();
    return txtPassword.getText();
  }

  /**
   * |[gԍGetter
   *
   * @return String
   */
  public String getPort() {
    return txtPort.getText();
  }

  /**
   * [UIDGetter
   *
   * @return String
   */
  public String getUserId() {
    return txtUserId.getText();
  }

  /**
   * zXgSetter
   *
   * @param txtHost String
   */
  public void setHost(String txtHost) {
    if (txtHost == null)
      txtHost = "";
    this.txtHost.setText(txtHost);
  }

  /**
   * pX[hSetter
   *
   * @param txtPassword String
   */
  public void setPassword(String txtPassword) {
    if(txtPassword==null)
      txtPassword="";
    this.txtPassword.setText(txtPassword);
  }

  /**
   * |[gԍSetter
   *
   * @param txtPort String
   */
  public void setPort(String txtPort) {
    if (txtPort == null)
      txtPort = "";
    this.txtPort.setText(txtPort);
  }

  /**
   * [UIDSetter
   *
   * @param txtUserId String
   */
  public void setUserId(String txtUserId) {
    if (txtUserId == null)
      txtUserId = "";
    this.txtUserId.setText(txtUserId);
  }

  /**
   * zXgGetter
   *
   * @return String
   */
  public String getHost() {
    return txtHost.getText();
  }

  /**
   * RXgN^
   *
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvConnectionDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^
   */
  public Xml2CsvConnectionDialog() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(null);
    txtHost.setText("");
    lblType.setText("pX[h");
    lblCsv.setText("[UID");
    lblIndex.setText("|[g");
    jPanel3.setBounds(new Rectangle(37, 20, 322, 105));
    jPanel3.setLayout(borderLayout1);
    gridLayout1.setHgap(5);
    gridLayout1.setRows(4);
    gridLayout1.setVgap(5);
    jPanel1.setLayout(gridLayout1);
    jPanel1.setBorder(null);
    lblXml.setText("zXg");
    txtUserId.setText("");
    gridLayout2.setHgap(5);
    gridLayout2.setRows(4);
    gridLayout2.setVgap(5);
    jPanel2.setLayout(gridLayout2);
    jPanel2.setBorder(null);
    borderLayout1.setHgap(10);
    borderLayout1.setVgap(10);
    txtPassword.setText("");
    btnCancel.setBounds(new Rectangle(249, 139, 110, 23));
    btnCancel.setText("LZ");
    btnCancel.addActionListener(new Xml2CsvConnectionDialog_btnCancel_actionAdapter(this));
    btnOk.setBounds(new Rectangle(134, 139, 100, 23));
    btnOk.setText("OK");
    btnOk.addActionListener(new Xml2CsvConnectionDialog_btnOk_actionAdapter(this));
    this.setResizable(false);
    getContentPane().add(panel1);
    jPanel1.add(lblXml, null);
    jPanel1.add(lblIndex, null);
    jPanel1.add(lblCsv, null);
    jPanel1.add(lblType, null);
    panel1.add(btnCancel, null);
    panel1.add(btnOk, null);
    jPanel3.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(txtHost, null);
    jPanel2.add(txtPort, null);
    jPanel2.add(txtUserId, null);
    jPanel2.add(txtPassword, null);
    jPanel3.add(jPanel1, BorderLayout.WEST);
    panel1.add(jPanel3, null);
  }

  /**
   * LZ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  /**
   * OK{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnOk_actionPerformed(ActionEvent e) {
    okFlag = true;
    dispose();
  }
}

class Xml2CsvConnectionDialog_btnCancel_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvConnectionDialog adaptee;

  Xml2CsvConnectionDialog_btnCancel_actionAdapter(Xml2CsvConnectionDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCancel_actionPerformed(e);
  }
}

class Xml2CsvConnectionDialog_btnOk_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvConnectionDialog adaptee;

  Xml2CsvConnectionDialog_btnOk_actionAdapter(Xml2CsvConnectionDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOk_actionPerformed(e);
  }
}
