package mki.xml2csv.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.table.*;

/**
 * Config_XML2CSV`}bsODialog
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvMappingDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JPanel jPanel3 = new JPanel();
  private GridLayout gridLayout1 = new GridLayout();
  private JPanel jPanel1 = new JPanel();
  private JLabel lblCsv = new JLabel();
  private JLabel lblXml = new JLabel();
  private JLabel lblType = new JLabel();
  private JTextField txtCsv = new JTextField();
  private JComboBox cmbType = new JComboBox();
  private JTextField txtXml = new JTextField();
  private GridLayout gridLayout2 = new GridLayout();
  private JPanel jPanel2 = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JButton btnOk = new JButton();
  private JButton btnCancel = new JButton();
  private String xmltag = null;
  /**
   * OK{^NbNꂽꍇtrueԂ
   */
  public boolean okFlag = false;
  private String[] typeData = {"","STRING", "INT", "DOUBLE"};
  private JLabel lblIndex = new JLabel();
  private boolean typeFlag = true;
  private JPanel jPanel5 = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JComboBox cmbIndex = new JComboBox();
  //DefaultComboBoxModel cmodel = new DefaultComboBoxModel();
  public DefaultTableModel tblmodel = null;
  private String title = "";
  private String csvname = "";

  /**
   * RXgN^
   *
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvMappingDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
      ConstructorCommon(title);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^
   *
   * @param dialog Dialog
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvMappingDialog(Dialog dialog, String title, boolean modal) {
    super(dialog, title, modal);
    try {
      jbInit();
      pack();
      ConstructorCommon(title);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^ʏ
   *
   * @param title String
   */
  private void ConstructorCommon(String title){
    //txtXml.setText(xmltag);
    txtXml.setEditable(false);

    DefaultComboBoxModel indexmodel = new DefaultComboBoxModel();
    indexmodel.addElement("");
    indexmodel.addElement("M");
    for (int i = 1; i < 101; i++) {
      indexmodel.addElement(String.valueOf(i));
    }
    cmbIndex.setModel(indexmodel);
    this.title = title;
  }

  /**
   * RXgN^
   */
  public Xml2CsvMappingDialog() {
    //this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(null);
    jPanel3.setBounds(new Rectangle(28, 22, 427, 105));
    jPanel3.setLayout(borderLayout1);
    gridLayout1.setHgap(5);
    gridLayout1.setRows(4);
    gridLayout1.setVgap(5);
    jPanel1.setLayout(gridLayout1);
    lblCsv.setText("CSVtB[h");
    lblXml.setText("XML^O");
    lblType.setText("CSVtB[h^Cv");
    gridLayout2.setHgap(5);
    gridLayout2.setRows(4);
    gridLayout2.setVgap(5);
    jPanel2.setLayout(gridLayout2);
    borderLayout1.setHgap(10);
    borderLayout1.setVgap(10);
    jPanel2.setBorder(null);
    jPanel1.setBorder(null);
    btnOk.setBounds(new Rectangle(232, 143, 100, 23));
    btnOk.setText("OK");
    btnOk.addActionListener(new Xml2CsvMappingDialog_btnOk_actionAdapter(this));
    btnCancel.setBounds(new Rectangle(347, 143, 110, 23));
    btnCancel.setText("LZ");
    btnCancel.addActionListener(new Xml2CsvMappingDialog_btnCancel_actionAdapter(this));
    txtXml.setText("");
    txtCsv.setText("");
    lblIndex.setText("INDEX");
    jPanel5.setLayout(borderLayout2);
    this.setResizable(false);
    jPanel2.add(txtXml, null);
    jPanel2.add(jPanel5, null);
    jPanel5.add(cmbIndex,  BorderLayout.WEST);
    jPanel2.add(txtCsv, null);
    jPanel2.add(cmbType, null);
    panel1.add(btnCancel, null);
    panel1.add(btnOk, null);
    jPanel3.add(jPanel1, BorderLayout.WEST);
    jPanel1.add(lblXml, null);
    jPanel1.add(lblIndex, null);
    jPanel1.add(lblCsv, null);
    jPanel1.add(lblType, null);
    jPanel3.add(jPanel2, BorderLayout.CENTER);
    panel1.add(jPanel3, null);
    this.getContentPane().add(panel1, BorderLayout.CENTER);
  }

  /**
   * LZ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  /**
   * XML^OGetter
   *
   * @return String
   */
  public String getXmltag(){
    return txtXml.getText();
  }

  /**
   * XML^OSetter
   *
   * @param str String
   */
  public void setXmltag(String str){
    txtXml.setText(str);
  }
  /**
   * IndexGetter
   *
   * @return String
   */
  public String getIndex(){
    return cmbIndex.getSelectedItem().toString();
    //return null;
  }

  /**
   * IndexSetter
   *
   * @param str String
   */
  public void setIndex(String str){
    cmbIndex.setSelectedItem(str);
    //txtIndex.setText(str);
  }
  /**
   * CSVtB[hGetter
   *
   * @return String
   */
  public String getCsv(){
    return txtCsv.getText();
  }

  /**
   * CSVtB[hSetter
   *
   * @param str String
   */
  public void setCsv(String str){
    txtCsv.setText(str);
    csvname = str;
  }
  /**
   * CSVtB[h^CvGetter
   *
   * @return String
   */
  public String getType(){
    return (String)cmbType.getSelectedItem();
  }

  /**
   * CSVtB[h^CvSetter
   *
   * @param str String
   */
  public void setType(String str){
    cmbType.setSelectedItem(str);
  }
  /**
   * CSVtB[h^CvtOGetter
   *
   * @return String
   */
  public boolean getTypeFlag(){
    return typeFlag;
  }

  /**
   * INDEXR{{bNXenablew肷
   *
   * @param flag boolean
   */
  public void setIndexEnable(boolean flag){
    cmbIndex.setEnabled(flag);
  }
  /**
   * CSVtB[heLXgenablew肷
   *
   * @param flag boolean
   */
  public void setCsvEditable(boolean flag){
    txtCsv.setEditable(flag);
  }
  /**
   * CSVtB[h^CvR{{bNXenablew肷
   *
   * @param flag boolean
   */
  public void setTypeEnabled(boolean flag){
    cmbType.setEnabled(flag);
  }
  /**
   * CSVtB[h^CvtOSetter
   *
   * @return String
   */
  public void setTypeFlag(boolean flag){
    this.typeFlag=flag;
    if(this.typeFlag){
      cmbType.setEnabled(true);
    }else{
      cmbType.setEnabled(false);
    }
  }
  /**
   * R{{bNXCSVtB[h^CṽXgݒ肷
   *
   * @return String
   */
  public void setCsvFieldType(String[] ary){
    typeData = new String[ary.length + 1];
    //typeData[0]="";
    //for(int i=1;i<ary.length + 1;i++){
      //typeData[i]=ary[i-1];
    //}
    DefaultComboBoxModel cmodel = new DefaultComboBoxModel();
    cmodel.addElement("");
    for (int i = 1; i < ary.length + 1; i++) {
      cmodel.addElement(ary[i-1]);
    }
    cmbType.setModel(cmodel);

  }

  /**
   * OK{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnOk_actionPerformed(ActionEvent e) {
    if(txtCsv.getText().equals("")){
      MessageDialog.showWarningMessage(this, "CSVtB[hw肵ĉ","");
      return;
    }
    for(int i=0;i<tblmodel.getRowCount();i++){
      //System.out.println(tblmodel.getValueAt(i,3));
      //System.out.println(getCsv());
      if(!(title.equals("XV") && csvname.equals(getCsv()))){
        if(tblmodel.getValueAt(i,3).equals(getCsv())){
          MessageDialog.showWarningMessage(this, "CSVtB[hdĂ܂","");
          return;
        }
      }
    }
    okFlag = true;
    dispose();
  }
}

class Xml2CsvMappingDialog_btnCancel_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvMappingDialog adaptee;

  Xml2CsvMappingDialog_btnCancel_actionAdapter(Xml2CsvMappingDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCancel_actionPerformed(e);
  }
}

class Xml2CsvMappingDialog_btnOk_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvMappingDialog adaptee;

  Xml2CsvMappingDialog_btnOk_actionAdapter(Xml2CsvMappingDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOk_actionPerformed(e);
  }
}
