import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import java.util.*;
import mki.xml2csv.access.*;
import mki.xml2csv.model.*;
import com.neocore.httpclient.NeoConnection;

class Xml2Csv{
	public static void main(String[] args){
		NeoConnection neo = null;
		String sessionId = null;
		ResourceBundle prop = null;
		
		String id = null;
		String configfile = null;
		for(int i=0;i<args.length;i++){
			if(args[i].equals("-id")){
				if(i+1 < args.length){
					id = args[i+1];
				}
			}
			if(args[i].equals("-configfile")){
				if(i+1 < args.length){
					configfile = args[i+1];
				}
			}
		}
		//System.out.println("id = " + id);
		//System.out.println("configfile = " + configfile);
		if(id == null && configfile == null){
			System.out.println("-id܂-configfilew肵Ă");
			return ;
		}
		
		try {
			prop = ResourceBundle.getBundle("xml2csv");
		}
		catch (Exception e) {
			System.out.println("e = " + e);
			e.printStackTrace();
		}
		String host = prop.getString("neocore.host");
		String port = prop.getString("neocore.port");
		String userid = prop.getString("neocore.userid");
		String password = prop.getString("neocore.password");
		String encoding = prop.getString("encoding");
		try {
			//NeoCoreT[oɃOC
			if (neo == null) {
				neo = new com.neocore.httpclient.NeoConnection(host, Integer.parseInt(port));
				sessionId = neo.login(userid, password);
			}
		} catch (Exception e) {
			System.out.println("NeoCoreւ̐ڑɎs܂B");
			System.out.println("e = " + e);
			//throw e;
		}

		String result = null;
		String strConfig = null;
		String configid = null;
		String query = null;
		Xml2CsvConfigModel config = new Xml2CsvConfigModel();
		Xml2CsvNeoCoreAccess neoaccess = null;
		try{
			//neoaccess = new Xml2CsvNeoCoreAccess(host,Integer.parseInt(port),userid,password);
			neoaccess = new Xml2CsvNeoCoreAccess(neo,sessionId);
		}catch(Exception e){
			System.out.println("e = " + e);
			e.printStackTrace();
		}

		if(configfile == null){
			//`擾
			try{
				config  = neoaccess.getConfigModel(id,encoding);
				query = config.getQuery();
			}catch(Exception e){
				System.out.println("e = " + e);
				e.printStackTrace();
			}
		}else{
			try{
				DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
				// hLgr_[𐶐
				DocumentBuilder builder = dbfactory.newDocumentBuilder();
				// p[XsDocumentIuWFNg擾
				Document doc = builder.parse(new File(configfile));
				// [gvf擾i^OFsitej
				Element root = doc.getDocumentElement();
				NodeList queryList = root.getElementsByTagName("query");
				//queryList.item(0)
				if(queryList.getLength() > 0){
					NodeList listChild = queryList.item(0).getChildNodes();
					//System.out.println("cnt = " + listChild.getLength());
					if(listChild.getLength() > 0){
						query = listChild.item(0).getNodeValue();
					}
				}
				queryList = root.getElementsByTagName("config");
				if(queryList.getLength() > 0){
					Element elm = (Element)queryList.item(0);
					id = elm.getAttribute("id");
					//System.out.println("idid = " + id);
				}
				
			}catch(Exception e){
				System.out.println("e = " + e);
				e.printStackTrace();
			}
		}
		configid = id;
		//System.out.println("configid = " + configid);
		//System.out.println("NG[ = " + query);
		
		try{
	        result = neo.queryXML(sessionId, query);
		}catch(Exception e){
			System.out.println("e = " + e);
			e.printStackTrace();
		}
		//System.out.println(" = " + result);

		OutputStreamWriter objOsr = null;
		BufferedWriter bw = null;
		try{
		objOsr = new OutputStreamWriter(new FileOutputStream(id + ".csv"));
		bw = new BufferedWriter(objOsr);
		StringBuffer csv = new StringBuffer();
		DomAccess dom = new DomAccess();
		Document doc = dom.parseString(result,encoding);
		Element root = doc.getDocumentElement();
		NodeList list = root.getElementsByTagName("result");
		for (int i=0; i < list.getLength() ; i++) {
			Node node = list.item(i);
			NodeList listChild = node.getChildNodes();
			boolean flag = false;
			for (int j=0; j < listChild.getLength() ; j++) {
				Node child = listChild.item(j);
				if(child.getNodeType() == Node.ELEMENT_NODE){
					Element elm = (Element)child;
					//System.out.println("type = " + elm.getTagName());
					//System.out.println("val = " + elm.getFirstChild().getNodeValue());

					/*if(i==0){
						if(j!=0){
							bw.write(",");
						}
						bw.write(elm.getTagName());
						//bw.newLine();
					}*/
					if(flag){
						bw.write(",");
					}
					bw.write(elm.getFirstChild().getNodeValue());
					flag = true;
				}
			}
			bw.newLine();
		}
		}catch(Exception e){
			System.out.println("e = " + e);
			e.printStackTrace();
		}finally{
			try{
				if(bw != null){
					bw.close();
				}
			}catch(Exception e1){
			}
		}
	}
}

