package mki.xml2csv.gui;

import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import mki.xml2csv.access.*;

/**
 * Config_XML2CSV`ꗗDialog
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvIdListDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JButton btnCancel = new JButton();
  private JButton btnOk = new JButton();
  private JScrollPane jScrollPane1 = new JScrollPane();
  /**
   * OK{^NbNꂽꍇtrueԂ
   */
  public boolean okFlag = false;
  private DefaultTableModel tblmodel = new Xml2CsvTableModel();
  private JTable jTable1 = new JTable();
  private String[] tblColNames = {"`ID","l"};

  /**
   * RXgN^
   *
   * @param frame Frame
   * @param title String
   * @param modal boolean
   */
  public Xml2CsvIdListDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * RXgN^
   */
  public Xml2CsvIdListDialog() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(null);
    btnCancel.setBounds(new Rectangle(357, 221, 110, 23));
    btnCancel.setText("LZ");
    btnCancel.addActionListener(new Xml2CsvIdListDialog_btnCancel_actionAdapter(this));
    btnOk.setBounds(new Rectangle(242, 221, 100, 23));
    btnOk.setText("OK");
    btnOk.addActionListener(new Xml2CsvIdListDialog_btnOk_actionAdapter(this));
    jScrollPane1.setBounds(new Rectangle(26, 27, 442, 177));
    jTable1.addMouseListener(new Xml2CsvIdListDialog_jTable1_mouseAdapter(this));
    this.setResizable(false);
    getContentPane().add(panel1);
    panel1.add(jScrollPane1, null);
    panel1.add(btnCancel, null);
    panel1.add(btnOk, null);
    jScrollPane1.getViewport().add(jTable1, null);
  }

  /**
   * `ꗗListɏݒ肷
   *
   * @param lds List
   */
  public void setIdList(java.util.List lds) {
    try {
      //java.util.List lds = neoaccess.getConfigIdMemoList();

      int i = 0;
      String[][] rowData = null;
      if(lds != null){
        rowData = new String[lds.size()][2];
        Iterator it = lds.iterator();
        while (it.hasNext()) {
          String[] str = (String[]) it.next();
          rowData[i][0] = str[0];
          rowData[i][1] = str[1];
          i++;
        }
      }
      jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      tblmodel.setDataVector(rowData, tblColNames);
      jTable1.setModel(tblmodel);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * Iꂽ`ID擾
   *
   * @return Object
   */
  public Object getSelectedId(){
    //return jList1.getSelectedValue();
    int row = jTable1.getSelectedRow();
    if(row != -1)
      return tblmodel.getValueAt(row,0);
    return null;
  }

  /**
   * LZ{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnCancel_actionPerformed(ActionEvent e) {
    dispose();
  }

  /**
   * OK{^NbN̏
   *
   * @param e ActionEvent
   */
  void btnOk_actionPerformed(ActionEvent e) {
    okFlag = true;
    dispose();
  }

  /**
   * Table_uNbN̏
   * OK{^Ɠl̏s
   *
   * @param e ActionEvent
   */
  void jTable1_mousePressed(MouseEvent e) {
    if(e.getClickCount()==2){
      btnOk.doClick();
    }
  }
}

class Xml2CsvIdListDialog_btnCancel_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvIdListDialog adaptee;

  Xml2CsvIdListDialog_btnCancel_actionAdapter(Xml2CsvIdListDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCancel_actionPerformed(e);
  }
}

class Xml2CsvIdListDialog_btnOk_actionAdapter implements java.awt.event.ActionListener {
  Xml2CsvIdListDialog adaptee;

  Xml2CsvIdListDialog_btnOk_actionAdapter(Xml2CsvIdListDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnOk_actionPerformed(e);
  }
}

class Xml2CsvIdListDialog_jTable1_mouseAdapter extends java.awt.event.MouseAdapter {
  Xml2CsvIdListDialog adaptee;

  Xml2CsvIdListDialog_jTable1_mouseAdapter(Xml2CsvIdListDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.jTable1_mousePressed(e);
  }
}
